from typing import Optional

from pydantic import BaseModel, constr


class TClient(BaseModel):

    codigo: constr(min_length=0, max_length=6)
    nome: constr(min_length=0, max_length=80)
    nomeFantasia: Optional[str]
    cnpjcpf: constr(min_length=11, max_length=14)
    cep: Optional[str]
    logradouro: Optional[str]
    bairro: Optional[str]
    numero: Optional[str]
    complemento: Optional[str]
    uf: Optional[str]
    cidade: Optional[str]
    ddd: Optional[str]
    fone: Optional[str]
    fax: Optional[str]
    identificador: Optional[str]
    celular: Optional[str]
    email: Optional[str]
    contato: Optional[str]
    site: Optional[str]
    rg: Optional[str]
    ie: Optional[str]
    grupo: Optional[str]
    agenteCobrador: Optional[str]
    receita: Optional[str]
    contaContabil: Optional[str]
    Representante: Optional[str]
    Vencimento: Optional[int]
    Etiqueta: Optional[int]
    GeraNFAuto: Optional[int]
    RetemINSS: Optional[int]
    AliquotaISS: Optional[str]
    IM: Optional[str]
    CampoExtra1: Optional[str]
    CampoExtra2: Optional[str]
    CampoExtra3: Optional[str]
    CampoExtra4: Optional[str]
    CampoExtra5: Optional[str]
    CampoExtra6: Optional[str]
    CampoExtra7: Optional[str]
    CampoExtra8: Optional[str]
    CampoExtra9: Optional[str]
    CampoExtra10: Optional[str]
    Exterior: Optional[int]
    Inseto_de_IE: Optional[int]


class TFornecedor(BaseModel):
    Codigo: Optional[str]
    Nome: str
    CNPJCPF: constr(min_length=11, max_length=14)
    CEP: Optional[str]
    Logradouro: Optional[str]
    Bairro: Optional[str]
    Numero: Optional[str]
    Complemento: Optional[str]
    UF: Optional[str]
    Cidade: Optional[str]
    DDD: Optional[str]
    Fone: Optional[str]
    Fax: Optional[str]
    Email: Optional[str]
    Contato: Optional[str]
    Site: Optional[str]
    RG: Optional[str]
    IE: Optional[str]
    Grupo: Optional[str]
    Receita: Optional[str]
    IM: Optional[str]
    Referencia: Optional[str]
    FinalidadeTED: Optional[str]
    FinalidadeDOC: Optional[str]
    Celular: Optional[str]
    Leiaute: Optional[str]
    Banco: Optional[str]
    BancoNumero: Optional[str]
    Agencia: Optional[str]
    CC: Optional[str]
    DVAg: Optional[str]
    DVCC: Optional[str]
    ServicoPublico: Optional[int]
    ICMS: Optional[int]
    IPI: Optional[int]
